import asyncio
import hashlib
import random
import sys
import os

#LCG
class LCG(object):
    def __init__(self, p, a, c):
        self.p = p
        self.a = a
        self.c = c
        self.x = random.randint(0, p)

    def generate(self):
        self.x = (self.a*self.x + self.c) % self.p
        return self.x


async def handle_echo(reader, writer):
    P = 83765940583638585693638595
    A = 9751638931180187
    C = 33
    lcg = LCG(P,A,C)
    writer.write(b"Hi, bro!\nTry this:\n")
    for i in range(0, 7):
        writer.write(bytes(str(lcg.generate()),'utf-8')+b"\n")
    wow = lcg.generate()
    writer.write(b"Predict next one!\n>>>")
    data = await reader.read(100)
    number = data.decode()
    if not number:
        return
    if number[:-1] == str(wow):
        writer.write(b"CONGRATULATIONS!\nMIEM{pR3d1ct1ng_1s_n0t_oNlY_f0r_0O0rAlce}\n")
        await writer.drain()
        writer.close()
        return
    else:
        writer.write(b"NONONO! Try next time!")

    await writer.drain()
    print("Close the connection")
    writer.close()
    print("Exiting")

async def main():
    server = await asyncio.start_server(
        handle_echo, '0.0.0.0', 8801)

    addr = server.sockets[0].getsockname()
    print(f'Serving on {addr}')

    async with server:
        await server.serve_forever()

asyncio.run(main())